/* Generated by Together */

package net.quartzware;

import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.awt.*;

/**
 BinaryPathDlg
 A Class that stores the path to a binary file.  The contents of the file are
 never seen by this class.  It only stores the path to the binary file. A binary
 file can be of any type (GIF, JPG, DOC) and RBEdit does not check the type. The
 programmer must know what type of file to expect.
 @author Anthony Tomarchio
 @version 0.7.1
*/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11/28/00 - Version 0.7.1 Susan Hunton
//                Checked for completeness
//              - Anthony Tomarchio - Updated ADT headers
//     11/16/00 - Version 0.3 Ben Leinweber
//                Removed '!=' from pseudocode
//     11/15/00 - Version 0.2 - Anthony Tomarchio
//                Added algorithm pseudocode
//     10/30/00 - Version 0.1 - Anthony Tomarchio
//                Initial Creation. JavaDocs created.

public class BinaryPath extends Value {

    /**
     Default Constructor

     PRE: none
     POST: The object is created.
    */
    public BinaryPath() {
    }

    /**
     Constructs a BinaryPath object using the given path.
     @param path the specified path to the binary file (File format)

     PRE: path not equal to null
     POST: The object is created.
    */
    public BinaryPath(File path) {
        // SET path
        this.path = path;
    }

    /**
     Constructs a BinaryPath object using the given path.
     @param path the specified path to the binary file (File format)

     PRE: path not equal to null
     POST: The object is created.
    */
    public BinaryPath(String path) {
        // SET path
        this.path = (new File(path));
    }

    public boolean editValue() {
        // INIT BinaryPathDlg with this

        FileDialog binPathDlg = new FileDialog(RBEdit.getRBEdit().getMainWindow(),
            bundle.getString("binaryPathDlg"));
        binPathDlg.setMode(FileDialog.LOAD);
        binPathDlg.setVisible(true);

        path = new File(binPathDlg.getDirectory() + binPathDlg.getFile());

        return false;
    }
    /**
     Sets the path variable with newValue. Catches an exception if format of path is
     incorrect.
     PRE: a string is passed to the function
     POST: path is set or exception raised
    */
    public void setValue(String newValue) {
            path = new File(newValue);
    }

    public String toString() {
        if (path != null) {
            return path.getPath();
        }
        else {
            return "";
        }
    }

    protected Object clone() {
        BinaryPath bp = new BinaryPath();
        bp.setValue(new String(path.getPath()));
        return bp;
    }

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     */
    //The path for the binary file the user selected
    private File path = new File("");

    //Internationalization variables
    Locale currentLocale = Locale.getDefault();
    ResourceBundle bundle = ResourceBundle.getBundle("RBEdit", currentLocale);

}
