/* Generated by Together */

package net.quartzware;

import javax.swing.*;
import java.lang.*;
import java.util.*;
import java.awt.event.*;
import java.awt.*;

/**
 BinaryPathDlg
 Displays dialog box that allows user to enter a binary path.
 User can look through files to find a binary path or can type
 the path into the file name field. The Binary File pointed to
 by the binary path will be opened when the user clicks the
 'open button'
 @author Susan Hunton
 @version 0.7.1
*/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11/29/00 - Version 0.7.1 - Susan Hunton
//                verified ADT headers and pseuodcode for correctness
//     11-17-00 - Version 0.31 - Ben Leinweber
//                Removed a language dependent comment in the psuedocode
//     11-16-00 - Version 0.3 - Susan Hunton
//                added pre and post conditions
//     11-15-00 - Version 0.2 - Susan Hunton
//                added algorithm pseudocode
//     10-30-00 - version 0.1 - Susan Hunton
//                created JavaDoc

public class BinaryPathDlg extends FileDialog {

    /**
     Constructs the BinaryPath dialog and shows it to the user.
     PRE: BinaryPath is not null, parent is not null
     POST: The class is created.
    */
    public BinaryPathDlg(Frame parent, BinaryPath bp) {
        super(parent);

        setModal(true);

        // SET path to bp
        path = bp;

        //make dialog visisble
        setVisible(true);
    }

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     */
    private BinaryPath path;
}
