/* Generated by Together */

package net.quartzware;

import java.lang.*;
import java.util.*;

/**
 BinaryVal
 A BinaryVal is a binary number of any length.  It is stored as an Vector of
 bytes.  When displayed to the user, it is displayed in hex.
 @author Tony Johansen
 @version 0.7.1
*/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11/28/00 - version 0.7.1 - Susan Hunton
//                added comments
//     11/17/00 - Version 0.31 - Ben Leinweber
//                Changed some comments to include the psudocode INIT
//     11/16/00 - Version 0.3 - Tony Johansen
//                added PRE and POST conditions
//     11/15/00 - Version 0.2 - Tony Johansen
//                added algorithm pseudocode
//     10/31/00 - Version 0.1 - Tony Johansen
//                wrote ADT Headers

public class BinaryVal extends Value {

    /**
     Constructs an empty Binary Value.

     PRE: None
     POST: The class is created.
    */
    public BinaryVal() {
        //INIT binVal to an empty vector.
        binVal = new Vector();
    }

    /**
     Constructs a Binary Value with a given value.
     @param val the value for Binary Value.

     Pre: None
     Post: The class is created.
    */
    public BinaryVal(Vector val) {
        //INIT binVal to vector that holds val.
        binVal = new Vector(val);
    }

    public boolean editValue() {
        return true;
    }

    public void setValue(String newValue) {
        //Clear binVal (current array of bytes)
        //FOR EACH byteString (2 characters) in newValue
        //    Convert current byteString into byte in hex
        //    add byte to binVal


        //This code does not yet work
        /*
        binVal.clear();

        String val = new String(newValue).trim();
        String hex = "";
        while (val.length() > 8) {
            System.out.println("val: " + val);
            hex = val.substring(val.length() - 8);
            val = val.substring(0, val.length() - 8);

            System.out.println("hex: " + hex);
            System.out.println("val: " + val + "\n\n\n\n\n\n");
            binVal.addElement(new Integer(Integer.parseInt(hex, 16)));
        }
        binVal.addElement(new Integer(Integer.parseInt(val, 16)));
        */
    }

    public Object clone() {
        return new BinaryVal(binVal);
    }

    public String toString() {
        if (binVal == null) {
            return "Binary Val not supported yet";
        }

        String value = "";
        for (int ndx = binVal.size() - 1; ndx >= 0; ndx--)
            value += Integer.toHexString(((Integer)binVal.elementAt(ndx)).intValue());

        return value;
    }

    //A BinValue is a Vector of bytes representing a binary number.
    private Vector binVal;
}
