/* Generated by Together */

package net.quartzware;

import javax.swing.*;
import java.lang.*;
import java.util.*;
import java.awt.event.*;
import java.awt.*;

/**
 A dialog which centers itself on the screen.  Useful as a base class for other dialogs.
 @author Chris Perluss
 @version 0.7.1
*/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11-29-00 - version 0.7.1 - Susan Hunton
//                added comments
//              - Anthony Tomarchio - updated ADT headers
//     11-19-00 - Version 0.5 - Chris Perluss
//                Wrote class

public class CenterDlg extends JDialog {

    /**
     Passes constructor parameters to its base class

     PRE: none
     POST: base class is created.
    */
    public CenterDlg() {
        center();
    }

    /**
     Passes constructor parameters to its base class
     PRE: none
     POST: base class is created.
    */
    public CenterDlg(Frame parent) {
        super(parent);
        //center dialog
        center();
    }

    /**
     Passes constructor parameters to its base class

     PRE: none
     POST: base class is created.
    */
    public CenterDlg(Frame parent, String title) {
        super(parent, title);

        center();
    }

    /**
     Centers this dialog

     PRE: none
     POST: dialog is centered
    */
    private void center() {
        int inset = 50;
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        setBounds(inset, inset, screenSize.width - inset*2, screenSize.height-inset*2);
    }
    /**
     This function returns a dimension based on the size of the components in the dialog
     PRE: None
     POST: Dimension is returned
    */
    public Dimension getPreferredSize() {
        return new Dimension((int)getSize().getWidth(),
            (int)getSize().getHeight() + 20);
    }
}
