/* Generated by Together */

package net.quartzware;

import javax.swing.*;
import java.lang.*;
import java.util.*;
import java.awt.event.*;

/**
 FindDlg
 Searches for a string designated by the user, in the resource
 bundles and shows the results to the user by highlighting the
 entry in the appropriate EditorWindow.
 @author Albert
 @version 0.7.1
*/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11/28/00 - Version 0.7.1 - Susan Hunton
//                Modified ADT header
//     11/20/00 - Version 0.6 - Anthony Tomarchio
//                Updated for internationalization
//     11-16-00 - version 0.3 Susan Hunton
//                Added pre and post conditions
//     11/15/00 - Version 0.2 - Anthony Tomarchio
//                Added algorithm pseudocode
//     10/31/00 - Version 0.1 - Albert Lee
//                Initial Creation. JavaDocs created.

public class FindDlg extends CenterDlg {

    JTextField searchField = new JTextField("Cancel");
    JLabel searchForLabel = new JLabel();
    JButton findButton = new JButton();
    JButton cancelButton = new JButton();
    JCheckBox searchKeysCheckBox = new JCheckBox();
    JCheckBox searchValuesCheckBox = new JCheckBox();
    JCheckBox searchCommentsCheckBox = new JCheckBox();
    JCheckBox searchAllFilesCheckBox = new JCheckBox();

    //Internationalization variables
    Locale currentLocale = Locale.getDefault();
    ResourceBundle bundle = ResourceBundle.getBundle("RBEdit", currentLocale);

    /**
     This constructor constructs the Find dialog box and shows it to the user

     PRE: none
     POST: The class is created.
    */
    public FindDlg() {
        // CALL doTheLayout
        doTheLayout();

        // CALL addListeners
        addListeners();

        // DISPLAY this dialog
        pack();

        // CALL setVisible
        setVisible(true);
    }

    /**
     This function handles the layout of the Find dialog box

     PRE: attributes have been set
     POST: GUI components have been added to the dlg and arranged appropriately.
    */
    private void doTheLayout() {
        //INIT Dialog GUI
        setTitle(bundle.getString("findDlg"));
        setResizable(false);
        getContentPane().setLayout(null);
        setSize(391,132);

        searchField.setDoubleBuffered(true);
        searchField.setBounds(84,12,175,25);
        getContentPane().add(searchField);

        searchForLabel.setText(bundle.getString("searchForLabel"));
        searchForLabel.setForeground(java.awt.Color.black);
        searchForLabel.setBounds(12,12,75,25);
        getContentPane().add(searchForLabel);

        findButton.setText(bundle.getString("findButton"));
        findButton.setActionCommand("Find");
        findButton.setSelected(true);
        findButton.setMnemonic((int)'F');
        findButton.setBounds(276,12,100,25);
        getContentPane().add(findButton);

        cancelButton.setText(bundle.getString("cancelButton"));
        cancelButton.setActionCommand("Cancel");
        cancelButton.setMnemonic((int)'C');
        cancelButton.setBounds(276,37,100,25);
        getContentPane().add(cancelButton);

        searchKeysCheckBox.setText(bundle.getString("searchKeysCheckBox"));
        searchKeysCheckBox.setActionCommand("jcheckBox");
        searchKeysCheckBox.setBounds(12,48,125,25);
        getContentPane().add(searchKeysCheckBox);

        searchValuesCheckBox.setText(bundle.getString("searchValuesCheckBox"));
        searchValuesCheckBox.setActionCommand("jcheckBox");
        searchValuesCheckBox.setBounds(12,72,125,25);
        getContentPane().add(searchValuesCheckBox);

        searchCommentsCheckBox.setText(bundle.getString("searchCommentsCheckBox"));
        searchCommentsCheckBox.setActionCommand("jcheckBox");
        searchCommentsCheckBox.setBounds(12,96,140,25);
        getContentPane().add(searchCommentsCheckBox);

        searchAllFilesCheckBox.setText(bundle.getString("searchAllFilesCheckBox"));
        searchAllFilesCheckBox.setActionCommand("jcheckBox");
        searchAllFilesCheckBox.setBounds(252,96,125,25);
        getContentPane().add(searchAllFilesCheckBox);
    }

    /**
     This function adds actionListeners to buttons which need to be watched.

     PRE: all GUI components have been initialized.
     POST: Listeners added to all componenets that need one.
    */
    private void addListeners() {
        // INIT Anonymous Listeners
        // ADD listeners to needed buttons

        findButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String searchText = searchField.getText();
                boolean keys = searchKeysCheckBox.isSelected();

                if (searchAllFilesCheckBox.isSelected()) {
                    searchAllFiles();
                } else {
                    searchCurrentFile();
                }
            }
        });

        cancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
            }
        });
    }

    /**
     This function searches for the given text through all bundles.

     PRE: A project is open.
     POST: An entry in a bundle may be selected.
    */
    private void searchAllFiles() {
        String searchText = searchField.getText();
        boolean keys = searchKeysCheckBox.isSelected();
        boolean vals = searchValuesCheckBox.isSelected();
        boolean coms = searchCommentsCheckBox.isSelected();

    }

    /**
     This function searches for the given text through the current bundle.

     PRE: none
     POST: An entry in the current bundle may be selected.
    */
    private void searchCurrentFile() {
        String searchText = searchField.getText();
        boolean keys = searchKeysCheckBox.isSelected();
        boolean vals = searchValuesCheckBox.isSelected();
        boolean coms = searchCommentsCheckBox.isSelected();
    }

}