package net.quartzware;

import javax.swing.*;
import java.lang.*;
import java.util.*;
import java.io.File;
import java.awt.event.*;
import javax.swing.event.*;
import java.beans.*;
import java.awt.*;
import java.net.*;
import javax.swing.border.*;

/**
 HelpDlg
 A dialog box which displays the html help topics for RBEdit
 @author Anthony Tomarchio
*/
public class HelpDlg extends JFrame {

	JEditorPane htmlPane;
	URL helpURL;
	JScrollPane htmlView;

    Locale currentLocale = Locale.getDefault();
    ResourceBundle bundle = ResourceBundle.getBundle("RBEdit", currentLocale);

    /**
     Default Constructor

     PRE: the html files are in the help/ directory and index.html exists
     POST: the class is constructed
    */
	public HelpDlg() {

		getContentPane().setLayout(new BorderLayout(0,0));
		setVisible(false);
		htmlPane = new JEditorPane();
		htmlPane.setEditable(false);
		getContentPane().add(htmlPane);

		String htmlIndex = null;
		try {
			htmlIndex = "file:" + System.getProperty("user.dir")
				+ System.getProperty("file.separator")
				+ "help"
				+ System.getProperty("file.separator")
				+ "index.html";

			helpURL = new URL(htmlIndex);
			htmlPane.setPage(helpURL);

		}
		catch (Exception e) {
		   System.err.println("Error opening help file: " + htmlIndex);
		}

		htmlView = new JScrollPane(htmlPane);
		getContentPane().add(htmlView, BorderLayout.CENTER);

		setTitle(bundle.getString("helpDlg"));

		pack();
	}

    /**
     Returns the dimensions of the window
     PRE: none
     POST: a Dimension is returned
    */
	public Dimension getPreferredSize() {
		return new Dimension(600,400);
	}
}
