/* Generated by Together */

package net.quartzware;

import java.lang.*;
import java.util.*;

/**
 IntArray
 A class which stores an array of integers.  There can be any number of integers
 up through INT_MAX.
 @author Anthony Tomarchio
 @version 0.7.1
*/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11/16/00 - Version 0.3 - Tony Johansen
//                Added PRE and POST conditions.
//     11/15/00 - Version 0.2 - Anthony Tomarchio
//                Added algorithm pseudocode
//     10/30/00 - Version 0.1 - Anthony Tomarchio
//                Initial Creation. JavaDocs created.

public class IntArray extends Value {

    /**
     Default constructor - created empty array

     PRE: None
     POST: The class is created
    */
    public IntArray() {
        // INIT integers with a new vector
        integers = new Vector();
    }

    /**
     Constructs the IntArray with a user specified int array
     @param array the array to be constructed

     PRE: Array is not null
     POST: The class is created
    */
    public IntArray(int[] array) {
        // INIT integers with new vector
        integers = new Vector();

        // FOR ndx from 0 to length of array INCREMENT by 1 LOOP
        //     ADD to integers from array[index]
        for (int ndx = 0; ndx < array.length; ndx++)
            integers.add(new Integer(array[ndx]));
    }

    /**
     Constructs the IntArray with a user specified integer array
     @param array the array to be constructed

     PRE: Array is not null
     POST: The class is created
    */
    public IntArray(Integer[] array) {
        // INIT integers with new vector
        integers = new Vector();

        // FOR ndx from 0 to length of array INCREMENT by 1 LOOP
        //     ADD to integers from array[ndx]
        for (int ndx = 0; ndx < array.length; ndx++)
            integers.add(array[ndx]);
    }

    /**
     Constructs the IntArray from a user specified vector
     @param array the array to be constructed

     PRE: The vector is not null
     POST: The class is created
    */
    public IntArray(Vector array) {
        // INIT integers with a new Vector (array)
        integers = new Vector(array);
    }

    public boolean editValue() {
        return true;
    }

    public Vector getValue() {
        return integers;
    }

    public String toString() {
        String value = "";
        for (int ndx = 0; ndx < integers.size(); ndx++)
            value += "" + integers.elementAt(ndx) + ",";

        if (value.equals("")) {
            return "";
        }

        return value.substring(0, value.length()-1);
    }

    public Object clone() {
        return new IntArray(integers);
    }

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     */
    private Vector integers;
}
