/* Generated by Together */

package net.quartzware;

import java.lang.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;

/**
 IntegerVal
 Integer Value is a data type which contains one Integer to be stored
 in a Resource Bundle.
 @author Tony Johansen
 @version 0.7.1
*/

//  Version History
//       1/31/01 - Version 1.0   Ben Hill
//                 Functionality implemented
//      11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                 Checked for missing ADT Headers and pseudocode.
//                 Converted tabs to spaces and fixed spacing errors
//      11/28/00 - Version 0.7.1 Susan Hunton
//                 modified adt header
//      11/17/00 - Version 0.3 Tony Johansen
//                 wrote PRE and POST conditions.
//      11/15/00 - Version 0.2 Tony Johansen
//                 added algorithm pseudocode.
//      10/31/00 - Version 0.1 Tony Johansen
//                 wrote ADT Headers.

public class IntegerVal extends Value {

    /**
     Constructs an IntegerVal with the given Integer.
     @param val the name of a Integer value

     PRE: val is not null
     POST: the class is created
    */
    public IntegerVal(Integer val) {
        intVal = val;   //INIT intVal equal to val.
    }

    /**
     Constructs an IntegerVal with the given int.
     @param val the name of a int value.

     PRE: none
     POST: the class is created
    */
    public IntegerVal(int val) {
        intVal = new Integer(val);  //INIT intVal with val forced
                                    //to an Integer Object.
    }

    /**
     Constructs an empty IntegerVal.

     PRE: none
     POST: the class is created
    */
    public IntegerVal() {
        intVal = new Integer(0);     //INIT intval to 0.

    }

    public boolean editValue() {
        return true;
    }

    public void setValue(String newValue) {
    try {
            intVal = new Integer(Integer.parseInt(newValue));
    } catch(NumberFormatException ex) {}
    }

    public String toString() {
        return "" + intVal;
    }

    public Object clone() {
        return new IntegerVal(intVal.intValue());
    }

    private Integer intVal; //An IntegerVal stores one Integer
                            //in the Resource Bundle
}
