/* Generated by Together */

package net.quartzware;

import java.lang.*;

/**
 Message
 Encapsulates the data and function of an internationalization 'Message'

 @author Chris Perluss
 @version 0.7.1
*/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11/29/00 - Version 0.7.1 Susan Hunton
//                modified adt header
//     11/16/00 - Version 0.3 Susan Hunton
//                added pre and post conditions
//     11/15/00 - Version 0.2 Ben Leinweber
//                Added algorithm pseudocode
//     10/30/00 - Version 0.1 Chris Perlus
//                Initial Creation.  Javadoc code added.

public class Message extends Value {

    /**
     Constructs this Message using the given String which is a properly
     formated message
     @param msg the message to use to construct this Message

     PRE: msg is not null
     POST: This class is created
    */
    public Message(String msg) {
        // SET message to msg
        message = msg;
    }

    /**
     Constructs a Message with a default value

     PRE: none
     POST: This class is created
    */
    public Message() {
        // SET message to empty string
        message = "";
    }

    /**
     creates a new MessageDlg so user can edit the message

     PRE: none
     POST: new MessageDlg is created
    */
    public boolean editValue() {
        // INIT MessageDlg using 'this'
        new MessageDlg(this);
        return false;
    }

    public String toString() {
        return message;
    }

    public Object clone() {
        return new Message(new String(message));
    }

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     */
    // The current message (which is a specially formated string)
    private String message;
}
