/* Generated by Together */

package net.quartzware;

import javax.swing.*;
import java.lang.*;
import java.util.*;
import javax.swing.border.*;
import java.awt.event.*;

/**
 MessageDlg
 A dialog box that displays a selected message and allows the user
 to edit it
 @author Albert Lee
 @version 0.7.1
*/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11/29/00 - Version 0.7.1 Susan Hunton
//                modified adt header, checked for pseudocode
//     11/27/00 - version 0.7 Anthony Tomarchio
//                Internationalized
//     11-18-00 - version 0.4 Chris Perluss
//                Inserted GUI code.
//     11-16-00 - version 0.3 Susan Hunton
//                added pre and post conditions
//     11-15-00 - version 0.2 Susan Hunton
//                added algorithm pseudocode
//     10-30-00 - version 0.1 Albert Lee
//                created Java Doc

public class MessageDlg extends CenterDlg {
    JLabel messageElementLabel = new JLabel();
    JComboBox elementNumberCombo = new JComboBox(new String[]{"0", "1"});
    JButton newElementButton = new JButton();
    JButton deleteElementButton = new JButton();
    JLabel choiceFormatLabel = new JLabel();
    JList limitList = new JList(new String[]{"[-inf, 0)", "[0, 1)", "[1, 2)", "[2, +inf]"});
    JCheckBox useChoiceFormatCheck = new JCheckBox();
    JPanel rbPanel = new JPanel();
    ButtonGroup rbGroup = new ButtonGroup();
    JRadioButton poundLimitRBtn = new JRadioButton();
    JRadioButton lessThanLimitRBtn = new JRadioButton();
    JRadioButton greaterThanLimitRBtn = new JRadioButton();
    JLabel limitLabel = new JLabel();
    JLabel elementLabel = new JLabel();
    JTextField limitValueField = new JTextField("1");
    JTextField elementValueField = new JTextField("One bomb has");
    JButton editAsChoiceButton = new JButton();
    JButton newLimitButton = new JButton();
    JButton deleteLimitButton = new JButton();
    JLabel fullMessageLabel = new JLabel();
    JTextArea fullMessageField = new JTextArea();
    JButton testButton = new JButton();
    JButton okButton = new JButton();
    JButton cancelButton = new JButton();

    //Internationalization variables
    Locale currentLocale = Locale.getDefault();
    ResourceBundle bundle = ResourceBundle.getBundle("RBEdit", currentLocale);

    /**
     This constructs the message dialog box and shows it to the user
     @param m the Message

     PRE: m not equal to null
     POST: The class is created.
    */
    public MessageDlg(Message m) {
        // SET msg to m
        msg = m;

        // CALL doTheLayout
        doTheLayout();

        // ADD Listeners
        doAddListeners();

        // DISPLAY the dialog
        pack();
        setVisible(true);
    }

    /**
     This function handles the layout of the message dialog box setting up
     all icons, buttons, and fields

     PRE: the attributes for this class have been set
     POST: GUI components have been added to the dialog and are arranged properly
    */
    private void doTheLayout() {
        // when new button is clicked, CALL function doTest
        setTitle(bundle.getString("messageDlg"));
        getContentPane().setLayout(null);
        setModal(true);
        setSize(500,451);
        setVisible(false);

        messageElementLabel.setText(bundle.getString("messageElementLabel"));
        messageElementLabel.setForeground(java.awt.Color.black);
        messageElementLabel.setBounds(12,12,200,25);
        getContentPane().add(messageElementLabel);

        elementNumberCombo.setBounds(12,36,200,25);
        getContentPane().add(elementNumberCombo);

        newElementButton.setText(bundle.getString("newElementButton"));
        newElementButton.setBounds(240,12,125,25);
        getContentPane().add(newElementButton);

        deleteElementButton.setText(bundle.getString("deleteElementButton"));
        deleteElementButton.setBounds(240,48,125,25);
        getContentPane().add(deleteElementButton);

        choiceFormatLabel.setText(bundle.getString("choiceFormatLabel"));
        getContentPane().add(choiceFormatLabel);
        choiceFormatLabel.setForeground(java.awt.Color.black);
        choiceFormatLabel.setBounds(12,84,200,25);

        limitList.setSelectionBackground(java.awt.Color.white);
        limitList.setDoubleBuffered(true);
        getContentPane().add(limitList);
        limitList.setBounds(12,144,156,108);

        useChoiceFormatCheck.setText(bundle.getString("useChoiceFormatCheck"));
        getContentPane().add(useChoiceFormatCheck);
        useChoiceFormatCheck.setBounds(12,108,200,25);

        poundLimitRBtn.setText(bundle.getString("poundLimitRBtn"));
        poundLimitRBtn.setBounds(0,0,150,25);
        rbGroup.add(poundLimitRBtn);
        rbPanel.add(poundLimitRBtn);

        lessThanLimitRBtn.setText(bundle.getString("lessThanLimitRBtn"));
        lessThanLimitRBtn.setBounds(0,24,175,25);
        rbGroup.add(lessThanLimitRBtn);
        rbPanel.add(lessThanLimitRBtn);

        greaterThanLimitRBtn.setText(bundle.getString("greaterThanLimitRBtn"));
        greaterThanLimitRBtn.setBounds(0,48,200,25);
        rbGroup.add(greaterThanLimitRBtn);
        rbPanel.add(greaterThanLimitRBtn);

        rbPanel.setLayout(null);
        rbPanel.setBounds(264,108,216,72);
        getContentPane().add(rbPanel);

        limitLabel.setText(bundle.getString("limitLabel"));
        getContentPane().add(limitLabel);
        limitLabel.setForeground(java.awt.Color.black);
        limitLabel.setBounds(180,192,85,25);

        elementLabel.setText(bundle.getString("elementLabel"));
        getContentPane().add(elementLabel);
        elementLabel.setForeground(java.awt.Color.black);
        elementLabel.setBounds(180,228,85,25);

        getContentPane().add(limitValueField);
        limitValueField.setBounds(276,192,200,25);

        getContentPane().add(elementValueField);
        elementValueField.setBounds(276,228,75,25);

        editAsChoiceButton.setText(bundle.getString("editAsChoiceButton"));
        getContentPane().add(editAsChoiceButton);
        editAsChoiceButton.setBounds(360,228,125,25);

        newLimitButton.setText(bundle.getString("newLimitButton"));
        getContentPane().add(newLimitButton);
        newLimitButton.setBounds(12,264,125,25);

        deleteLimitButton.setText(bundle.getString("deleteLimitButton"));
        getContentPane().add(deleteLimitButton);
        deleteLimitButton.setBounds(144,264,125,25);

        fullMessageLabel.setText(bundle.getString("fullMessageLabel"));
        getContentPane().add(fullMessageLabel);
        fullMessageLabel.setForeground(java.awt.Color.black);
        fullMessageLabel.setBounds(12,300,200,25);

        fullMessageField.setText("" + msg);
        fullMessageField.setBounds(12,324,480,72);
        getContentPane().add(fullMessageField);

        testButton.setText(bundle.getString("testButton"));
        testButton.setMnemonic((int)'T');
        getContentPane().add(testButton);
        testButton.setBounds(168,408,100,25);

        okButton.setText(bundle.getString("okButton"));
        okButton.setMnemonic((int)'O');
        getContentPane().add(okButton);
        okButton.setBounds(276,408,100,25);

        cancelButton.setText(bundle.getString("cancelButton"));
        cancelButton.setMnemonic((int)'C');
        getContentPane().add(cancelButton);
        cancelButton.setBounds(384,408,100,25);

        cancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
            }
        });
    }

    /**
     Adds necessary listeners

     PRE:  gui components have been initialized
     POST: gui componenets have listeners
    */
    public void doAddListeners() {
        newElementButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("This will add a new element in the elements drop down menu");
            }
        });

        deleteElementButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("This will delete the current element in the elements drop down menu");
            }
        });

        editAsChoiceButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                new MessageDlg(msg);
            }
        });

        newLimitButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("This will add a new limit in the limits list box");
            }
        });

        deleteLimitButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("This will delete the current limit in the limits list box");
            }
        });

        testButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                new MessageTestDlg(msg);
            }
        });

        okButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
            }
        });

        cancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
            }
        });
    }

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     */
    private Message msg;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     */
    private MessageTestDlg testDlg;
}
