/* Generated by Together */

package net.quartzware;

import javax.swing.*;
import javax.swing.table.*;
import java.awt.event.*;
import java.util.*;

/**
 MessageTestDlg
 Displays a test of the message so the user can verify that the message is
 correct.
 @author Chris Perluss
 @version 0.7.1
*/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11/28/00 - version 0.7.1 Susan Hunton
//                modified adt header, checked pseudocode
//              - Anthony Tomarchio - Internationalized
//     11/19/00 - version 0.5 Anthony Tomarchio
//                Created dialog in Visual Cafe
//                Inserted GUI code into source code
//                Formatted code for organization and readability
//     11/17/00 - Version 0.3 Tony Johansen
//                wrote PRE and POST conditions.
//     11/01/00 - Version 0.2 Chris Perluss
//                created Javadoc and wrote pseudocode.

public class MessageTestDlg extends CenterDlg {
    JTable elementTable;
    JLabel fullTestMessageLabel = new JLabel();
    JTextArea fullTestMessageField = new JTextArea();
    JLabel testMessageValueLabel = new JLabel();
    JButton runTestButton = new JButton();
    JButton closeButton = new JButton();

    //Internationalization variables
    Locale currentLocale = Locale.getDefault();
    ResourceBundle bundle = ResourceBundle.getBundle("RBEdit", currentLocale);

    /**
     Constructs and shows this dialog

     PRE: m is not null
     POST: The class is constructed
    */
    public MessageTestDlg(Message m) {
        // INIT msg with m
        msg = m;

        // CALL doTheLayout
        doTheLayout();

        // ADD listeners
        doAddListeners();

        // DISPLAY this dialog
        pack();
        setVisible(true);
    }

    /**
     Lays out this dialog

     PRE: attributes have been set
     POST: GUI components have been added to the dlg and arranged appropriately.
    */
    public void doTheLayout() {
        // LAYOUT this dialog
        setTitle(bundle.getString("messageTestDlg"));
        setResizable(false);
        setModal(true);
        getContentPane().setLayout(null);
        setSize(500,198);
        setVisible(false);

        Vector rows = new Vector();
        Vector cols = new Vector();
        cols.add("0");
        cols.add("napalm");
        rows.add(cols);

        cols = new Vector();
        cols.add("1");
        cols.add("1");
        rows.add(cols);

        Vector colNames = new Vector();
        colNames.add("Element Number");
        colNames.add("Test Value");

        DefaultTableModel model = new DefaultTableModel(rows, colNames);

        // INIT table
        elementTable = new JTable(model);
        elementTable.setBounds(12,36,180,144);

        getContentPane().add(elementTable);

        fullTestMessageLabel.setText(bundle.getString("fullTestMessageLabel"));
        fullTestMessageLabel.setForeground(java.awt.Color.black);
        fullTestMessageLabel.setBounds(204,12,200,25);
        getContentPane().add(fullTestMessageLabel);

        fullTestMessageField.setBounds(204,36,276,96);
        getContentPane().add(fullTestMessageField);

        testMessageValueLabel.setText(bundle.getString("testMessageValueLabel"));
        testMessageValueLabel.setForeground(java.awt.Color.black);
        testMessageValueLabel.setBounds(12,12,200,25);
        getContentPane().add(testMessageValueLabel);

        runTestButton.setText(bundle.getString("runTestButton"));
        runTestButton.setBounds(228,156,100,25);
        getContentPane().add(runTestButton);

        closeButton.setText(bundle.getString("closeButton"));
        closeButton.setBounds(360,156,100,25);
        getContentPane().add(closeButton);
    }

    /**
     Adds necessary listeners

     PRE:  gui components have been initialized
     POST: gui componenets have listeners
    */
    public void doAddListeners() {
        runTestButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("This will display a string showing what your message will look like using the given test values");
            }
        });

        closeButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
            }
        });
    }

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     */
    private Message msg;
}
