/* Generated by Together */

package net.quartzware;

import java.lang.*;
import java.util.*;
import java.net.*;

/**
 ObjectVal
 Holds the necessary information to create an instance of a class on the fly.
 In other words, it contains the path to a .class file and the parameters to
 pass to the constructor.
 @author Tony Johansen
 @version 0.7.1
*/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11/29/00 - version 0.7.1 Susan Hunton
//                Modified adt header, checked for pseudocode
//     11/17/00 - Version 0.3 Tony Johansen
//                added PRE and POST conditions.
//     11/15/00 - Version 0.2 Tony Johansen
//                added algorithm pseudocode.
//     10/31/00 - Version 0.1 Tony Johansen
//                wrote ADT Headers.

public class ObjectVal extends Value {

    /**
     Constructs an ObjectVal with an Object type.
     @param val value used to initialize this class.

     PRE: val is not null
     POST: The class is created.
    */
    public ObjectVal(String val) {
        //init this ObjectVal using val.
        value = val;
    }

    /**
     Constructs an empty Object Value.

     PRE: None.
     POST: The class is created.
    */
    public ObjectVal() {
        value = "";
    }

    /**
     Allows the editing of a value
    */
    public boolean editValue() {
        return true;
    }

    /**
     Sets value to newValue
    */
    public void setValue(String newValue) {
        value = new String(newValue);
    }

    public String toString() {
        return value;
    }

    public Object clone() {
        return new ObjectVal(new String(value));
    }

    String value;
}
