/* Generated by Together */

package net.quartzware;

import javax.swing.*;
import java.awt.event.*;
import java.lang.*;
import net.quartzware.Project;
import java.util.*;
import java.awt.*;

/**
 PrefDlg
 Allows the user to change project preferences
 @author Chris Perluss
 @version 0.7.1
*/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11/28/00 - Version 0.7.1 - Susan Hunton
//                modified adt header, checked pseudocode
//     11/20/00 - Version 0.6 - Anthony Tomarchio
//                Updated for internationalization
//     11-18-00 - version 0.5 Ben Leinweber
//                Added GUI code created by visual cafe (Created by Tony Tomarchio)
//                Formated GUI code created by visual cafe to be more readable
//     11-16-00 - version 0.3 Susan Hunton
//                added pre and post conditions
//     11-15-00 - version 0.2 Susan Hunton
//                added algorithm pseudocode
//     11-01-00 - version 0.1 Chris Perluss
//                created Java Doc


public class PrefDlg extends CenterDlg {

    JLabel unchangedLabel = new JLabel();
    JLabel backgroundLabel1 = new JLabel();
    JLabel foregroundLabel1 = new JLabel();
    JButton background1Button = new JButton();
    JButton foreground1Button = new JButton();
    JLabel changedLabel = new JLabel();
    JLabel backgroundLabel2 = new JLabel();
    JLabel foregroundLabel2 = new JLabel();
    JButton background2Button = new JButton();
    JButton foreground2Button = new JButton();
    JCheckBox writeEscapedCBox = new JCheckBox();
    JCheckBox listAlphabeticallyCBox = new JCheckBox();
    JLabel defaultFieldsLabel = new JLabel();
    JCheckBox displayKeyCBox = new JCheckBox();
    JCheckBox displayValueCBox = new JCheckBox();
    JCheckBox displayParentCBox = new JCheckBox();
    JCheckBox displayCommentsCBox = new JCheckBox();
    JButton okButton = new JButton();
    JButton cancelButton = new JButton();

    //Internationalization variables
    Locale currentLocale = Locale.getDefault();
    ResourceBundle bundle = ResourceBundle.getBundle("RBEdit", currentLocale);

    /**
     Constructs this dialog and fills in the fields with the values in cfg
     @param cfg the Project.Config to modify

     PRE: cfg not equal to null
     POST: The class is created.
    */
    public PrefDlg(Project.Config cfg) {
        // CALL doTheLayout
        doTheLayout();

        // ADD listeners
        doAddListeners();

        // CALL pack
        pack();

        // CALL setVisible
        setVisible(true);
    }

    /**
     Sets the layout of the dialog

     PRE: the attributes for this class have been set
     POST: GUI components have been added to the dialog and are arranged properly
    */
    private void doTheLayout() {
        // INIT gui - created by Visual Cafe
        setTitle(bundle.getString("prefDlg"));
        setModal(true);
        setResizable(false);
        getContentPane().setLayout(null);
        setSize(384,253);
        setVisible(false);

        unchangedLabel.setText(bundle.getString("unchangedLabel"));
        unchangedLabel.setForeground(java.awt.Color.black);
        unchangedLabel.setBounds(12,12,150,25);
        getContentPane().add(unchangedLabel);

        backgroundLabel1.setText(bundle.getString("backgroundLabel"));
        backgroundLabel1.setForeground(java.awt.Color.black);
        backgroundLabel1.setBounds(12,36,75,25);
        getContentPane().add(backgroundLabel1);

        foregroundLabel1.setText(bundle.getString("foregroundLabel"));
        foregroundLabel1.setForeground(java.awt.Color.black);
        foregroundLabel1.setBounds(12,60,75,25);
        getContentPane().add(foregroundLabel1);

        background1Button.setBounds(96,39,50,20);
        getContentPane().add(background1Button);

        foreground1Button.setBounds(96,63,50,20);
        getContentPane().add(foreground1Button);

        changedLabel.setText(bundle.getString("changedLabel"));
        changedLabel.setForeground(java.awt.Color.black);
        changedLabel.setBounds(12,96,150,25);
        getContentPane().add(changedLabel);

        backgroundLabel2.setText(bundle.getString("backgroundLabel"));
        backgroundLabel2.setForeground(java.awt.Color.black);
        backgroundLabel2.setBounds(12,120,75,25);
        getContentPane().add(backgroundLabel2);

        foregroundLabel2.setText(bundle.getString("foregroundLabel"));
        foregroundLabel2.setForeground(java.awt.Color.black);
        foregroundLabel2.setBounds(12,144,75,25);
        getContentPane().add(foregroundLabel2);

        background2Button.setBounds(96,123,50,20);
        getContentPane().add(background2Button);

        foreground2Button.setBounds(96,147,50,20);
        getContentPane().add(foreground2Button);

        writeEscapedCBox.setText(bundle.getString("writeEscapedCBox"));
        writeEscapedCBox.setBounds(192,12,175,25);
        getContentPane().add(writeEscapedCBox);

        listAlphabeticallyCBox.setText(bundle.getString("listAlphabeticallyCBox"));
        listAlphabeticallyCBox.setBounds(192,36,175,25);
        getContentPane().add(listAlphabeticallyCBox);

        defaultFieldsLabel.setText(bundle.getString("defaultFieldsLabel"));
        defaultFieldsLabel.setForeground(java.awt.Color.black);
        defaultFieldsLabel.setBounds(192,72,150,25);
        getContentPane().add(defaultFieldsLabel);

        displayKeyCBox.setText(bundle.getString("displayKeyCBox"));
        displayKeyCBox.setBounds(204,96,175,25);
        getContentPane().add(displayKeyCBox);

        displayValueCBox.setText(bundle.getString("displayValueCBox"));
        displayValueCBox.setBounds(204,120,175,25);
        getContentPane().add(displayValueCBox);

        displayParentCBox.setText(bundle.getString("displayParentCBox"));
        displayParentCBox.setBounds(204,144,175,25);
        getContentPane().add(displayParentCBox);

        displayCommentsCBox.setText(bundle.getString("displayCommentsCBox"));
        displayCommentsCBox.setBounds(204,168,175,25);
        getContentPane().add(displayCommentsCBox);

        okButton.setText(bundle.getString("okButton"));
        okButton.setMnemonic((int)'O');
        okButton.setBounds(156,216,100,25);
        getContentPane().add(okButton);

        cancelButton.setText(bundle.getString("cancelButton"));
        cancelButton.setMnemonic((int)'C');
        cancelButton.setBounds(264,216,100,25);
        getContentPane().add(cancelButton);
    }

    /**
     Adds necessary listeners

     PRE:  gui components have been initialized
     POST: gui componenets have listeners
    */
    public void doAddListeners() {
        okButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
            }
        });

        cancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
            }
        });

        background1Button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JColorChooser.showDialog(PrefDlg.this, "Select Unchanged Background Color", Color.white);
            }
        });

        foreground1Button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JColorChooser.showDialog(PrefDlg.this, "Select Unchanged Foreground Color", Color.gray);
            }
        });

        background2Button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JColorChooser.showDialog(PrefDlg.this, "Select Changed Background Color", Color.white);
            }
        });

        foreground2Button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JColorChooser.showDialog(PrefDlg.this, "Select Changed Foreground Color", Color.black);
            }
        });
    }

    private Project.Config config;
}
