/* Generated by Together */

package net.quartzware;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.lang.*;
import java.util.*;
import javax.swing.tree.*;
import java.beans.*;

/**
 ProjectWindow
 @author Ben Leinweber
 @version 0.7.1

 The Project Window displays all of the resource bundles in the project in a
 tree format, and allows the user to open a Resource Bundle in its Editor Window
*/

// Revision History
//   11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//              Checked for missing ADT Headers and pseudocode.
//              Converted tabs to spaces and fixed spacing errors
//   11/20/00 - Version 0.6 Chris Perluss
//              Now draws in the MainWindow.
//              Anthony Tomarchio - Updated for internationalization
//   11/17/00 - Version 0.31 Ben Leinweber
//              Removed '!=' from pseudocode and put pseudocode in-line
//              with actual code.
//   11/15/00 - Version 0.3 Chris Perluss
//              added pseudocode algorithms and pre & post conditions
//   10/30/00 - Version 0.1 Ben Leinweber
//              created initial version


public class ProjectWindow extends InternalWindow implements TreeModelListener {

    //Internationalization variables
    Locale currentLocale = Locale.getDefault();
    ResourceBundle bundle = ResourceBundle.getBundle("RBEdit", currentLocale);

    /**
     Setup the project window using the given project
     @param p An opened project

     PRE: p is not equal to null
     POST: The class is created
    */
    public ProjectWindow(Project p) {
        super("", true, false, false, true);

        setTitle(bundle.getString("projectWindow"));

        menuItem = new JMenuItem("Project Window");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                try {
                    ProjectWindow.this.setSelected(true);
                    RBEdit.getRBEdit().getMainWindow().setSelectedTab(hiddenComponent);
                } catch (PropertyVetoException ex) {}
            }
        });

        // INIT project with p
        project = p;

        // CALL subroutine to lay out this window
        doTheLayout();
        pack();

        // DISPLAY this window
        setVisible(true);

        addInternalFrameListener(new InternalFrameAdapter() {
            public void internalFrameClosing(InternalFrameEvent e) {
                RBEdit.getRBEdit().getMainWindow().removeTab(ProjectWindow.this);
                RBEdit.getRBEdit().getMainWindow().removeMenuItem(menuItem);
            }

            public void internalFrameActivated(InternalFrameEvent e) {
                if (RBEdit.getRBEdit() != null && RBEdit.getRBEdit().getMainWindow() != null) {
                    RBEdit.getRBEdit().getMainWindow().setSelectedTab(hiddenComponent);
                }
            }
        });
    }

    /**
     Lays out the window

     PRE: attributes have been set
     POST: GUI components have been added to the dlg and arranged appropriately.
    */
    public void doTheLayout() {
        // CREATE layout for this window
        setDoubleBuffered(true);

        tree = new JTree(project);
        tree.setBounds(0,0,150,300);
        tree.setShowsRootHandles(true);
        tree.setToggleClickCount(250);
        setLocation(5, 5);
        getContentPane().add(tree);

        tree.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                if (tree.getRowForLocation(e.getX(), e.getY()) == -1) {
                    return;
                }

                ResBundle bund = (ResBundle)tree.getPathForLocation(e.getX(),
                    e.getY()).getLastPathComponent();

                if (e.getClickCount() == 2) {
                    RBEdit.getRBEdit().getMainWindow().openEditorWindow(bund);
                }
            }
        });
    }

    public Dimension getPreferredSize() {
        return new Dimension(150, 315);
    }

    /**
     Sets a new project
    */
    public void setProject(Project project) {
        this.project = project;
    }

    /**
     Gets the project that this ProjectWindow is drawing.
     @returns the project that is currently open
    */
    public Project getProject() {
        return project;}

    /**
     Gets whatever bundle is currently selected in the tree
     @returns A Resource Bundle
    */
    public ResBundle getSelectedBundle() {
        if (tree.getSelectionPath() == null) {
            return null;
        } else {
            return (ResBundle)tree.getSelectionPath().getLastPathComponent();
        }
    }

    public JMenuItem getMenuItem() {
        return menuItem;
    }

    public String getTabName() {
        return "Project";
    }

    public String getTooltipText() {
        return "Project Window";
    }

    public void treeNodesChanged(TreeModelEvent tme) {
        tree.invalidate();
    }

    public void treeNodesInserted(TreeModelEvent tme) {
        tree.invalidate();
    }

    public void treeNodesRemoved(TreeModelEvent tme) {
        tree.invalidate();
    }

    public void treeStructureChanged(TreeModelEvent tme) {
        tree.invalidate();
    }

    /**
     JTree used to draw the Project in this window.
    */
    private JTree tree;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     */
    private Project project;

    JMenuItem menuItem;
}
