/* Generated by Together */

package net.quartzware;

import java.util.Vector;

import java.lang.*;
import java.util.*;

/**
  The StringArray datatype contains a Vector of Strings to be saved into
  a Resource Bundle.
  @author Anthony Tomarchio
  @version 0.7.1
*/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11/29/00 - Version 0.7.1 - Tony Johansen
//                added pseudocode and added ADT
//                headers to editValue and toString.
//     11/17/00 - Version 0.3 - Susan Hunton
//                added pre and post conditions
//     11/15/00 - Version 0.2 - Anthony Tomarchio
//                Added algorithm pseudocode
//     10/30/00 - Version 0.1 - Anthony Tomarchio
//                Initial Creation. JavaDocs created.

public class StringArray extends Value {

    /**
     Constructs the StringArray with a given array of Strings
     @param array the array to be constructed

     PRE: strArray is not null
     POST: The class is created
    */
    public StringArray(String[] strArray) {
        // INIT array with new vector
        array = new Vector();

        // FOR ndx from 0 to length of strArray INCREMENT by 1 LOOP
        for (int ndx = 0; ndx < strArray.length; ndx++)

            //ADD to array from strArray[index]
            array.add(strArray[ndx]);
    }

    /**
     Constructs the StringArray with a given Vector
     @param array the vector to be constructed

     PRE:  array is not null
     POST: The class is created
    */
    public StringArray(Vector array) {
        //INIT array with a new Vector (array)
        this.array = new Vector(array);
    }

    /**
     Default constructor - creates empty StringArray

     PRE:  none
     POST: The class is created
    */
    public StringArray() {
         // INIT array with new Vector
            array = new Vector();
        }

    /**
     This function will allow the user to edit the value in this entry.  It
     returns true if in-label editing is required, but false if a dialog will
     handle the editing.
     @return Whether to do in label editing of this value

     PRE:  The entry that this Value is a part of must be in an open Edior
           Window
     POST: This value may be modified.
    */
    public boolean editValue() {
        // INIT StringArrayDlg with this
        new StringArrayDlg(this);
        return false;
    }

    public Vector getValue() {
        return array;
    }

    /**
     This function converts an array to a string.
     @return a string.

     PRE:  a cell in the resource bundle is clicked.
     POST: The array is now a string.
    */
    public String toString() {
        String value = "";
        for (int ndx = 0; ndx < array.size(); ndx++)
            value += "" + array.elementAt(ndx) + ",";
        if (value.equals("")) {
            return "";
        }

        return value.substring(0, value.length()-1);
    }

    public Object clone() {
        Vector newVals = new Vector();

        for (int ndx = 0; ndx < newVals.size(); ndx++)
            newVals.add(new String("" + array.elementAt(ndx)));

        return new StringArray(newVals);

    }

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     */
    private Vector array;
}
