/* Generated by Together */

package net.quartzware;

import javax.swing.*;
import javax.swing.table.*;
import java.lang.*;
import java.util.*;
import java.awt.event.*;
import java.net.*;

/**
 Displays a String Array and allows the user to edit it
 @author Albert Lee
 @version 0.7.1
*/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11/27/00 - version 0.7 Anthony Tomarchio
//                Internationalized
//     11/19/00 - version 0.5 Anthony Tomarchio
//                Inserted GUI code into source code
//     11/17/00 - version 0.31 Ben Leinweber
//                Removed some language specific stuff in pseudocode
//     11/16/00 - version 0.3 Susan Hunton
//                added pre and post conditions
//     11/15/00 - version 0.2 Susan Hunton
//                added algorithm pseudocode
//     10/30/00 - version 0.1 Albert Lee
//                created Java Doc

public class StringArrayDlg extends CenterDlg {

    // GUI elements declaration
    JButton okButton = new JButton();
    JButton cancelButton = new JButton();
    JButton modifyButton = new JButton();
    JButton addButton = new JButton();
    JButton removeButton = new JButton();
    JButton upArrowButton = new JButton();
    JButton downArrowButton = new JButton();
    JTable table = new JTable();
    ImageIcon upArrowIcon;
    ImageIcon downArrowIcon;

    //Internationalization variables
    Locale currentLocale = Locale.getDefault();
    ResourceBundle bundle = ResourceBundle.getBundle("RBEdit", currentLocale);


    /**
     This function constructs the String Array Dialog box and shows it
     @param sa The string array used to set up the dialog

     PRE: sa not equal to null
     POST: The dialog is created
    */
    public StringArrayDlg(StringArray sa) {
        // CALL doTheLayout
        doTheLayout();

        // ADD Listeners
        doAddListeners();

        // CALL pack
        pack();

        // DISPLAY the dialog
        setVisible(true);
    }

    /**
     This function handles the layout of the string array dialog box

     PRE: the attributes for this class have been set
     POST: GUI components have been added to the dialog and are arranged properly

    */
    private void doTheLayout() {
        // INIT GUI - created by Visual Cafe

        //INIT String Array Dialog
        setTitle(bundle.getString("stringArrayDlg"));
        getContentPane().setLayout(null);
        setModal(true);
        setSize(405,195);
        setVisible(false);

        //INIT ok button
        okButton.setText(bundle.getString("okButton"));
        okButton.setMnemonic((int)'O');
        okButton.setBounds(288,12,100,25);
        getContentPane().add(okButton);

        //INIT cancel button
        cancelButton.setText(bundle.getString("cancelButton"));
        cancelButton.setMnemonic((int)'C');
        cancelButton.setBounds(288,48,100,25);
        getContentPane().add(cancelButton);

        //INIT modify button
        modifyButton.setText(bundle.getString("modifyButton"));
        modifyButton.setMnemonic((int)'M');
        modifyButton.setBounds(288,84,100,25);
        getContentPane().add(modifyButton);

        //INIT add button
        addButton.setText(bundle.getString("addButton"));
        addButton.setMnemonic((int)'A');
        addButton.setBounds(288,120,100,25);
        getContentPane().add(addButton);

        //INIT remove button
        removeButton.setText(bundle.getString("removeButton"));
        removeButton.setMnemonic((int)'R');
        getContentPane().add(removeButton);
        removeButton.setBounds(288,156,100,25);

        //INIT up arrow button
        upArrowButton.setBounds(216,60,50,25);
        getContentPane().add(upArrowButton);
            upArrowIcon = new ImageIcon(RBEdit.class.getResource(bundle.getString("upArrowIcon")));
            upArrowButton.setIcon(upArrowIcon);

        //INIT down arrow button
        downArrowButton.setBounds(216,108,50,25);
        getContentPane().add(downArrowButton);
        downArrowIcon = new ImageIcon(RBEdit.class.getResource(bundle.getString("downArrowIcon")));
        downArrowButton.setIcon(downArrowIcon);

        // INIT table
        Vector rows = new Vector();
        Vector cols = null;

        for (int ndx = 0; ndx < array.getValue().size(); ndx++) {
            cols = new Vector();
            cols.add(array.getValue().elementAt(ndx));
            cols.add(array.getValue().elementAt(ndx));
            rows.add(cols);
        }
        Vector colNames = new Vector();
        colNames.add("Value");
        colNames.add("Parent Value");

        DefaultTableModel model = new DefaultTableModel(rows, colNames);

        table = new JTable(model);
        table.setBounds(12,12,180,168);
        getContentPane().add(table);
    }

    /**
     Adds necessary listeners

     PRE:  gui components have been initialized
     POST: gui componenets have listeners
    */
    public void doAddListeners() {
        // INIT and ADD listeners

        cancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
            }
        });

        okButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
            }
        });

        modifyButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("This will allow the user to edit the currently selected string in the list");
            }
        });

        addButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("This will add a new string to the list");
            }
        });

        removeButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("This will remove the selected string from the list");
            }
        });

        upArrowButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("This will move the selected string up in the list");
            }
        });

        downArrowButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("This will move the selected string down in the list");
            }
        });
    }

    /**
     This function handles the testing of the string array

     PRE: message dlg is open
     POST: none
    */
    public void doTest() {
        // CALL test dialog constructor
    }

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     */
    private StringArray array = new StringArray();
}
