/* Generated by Together */

package net.quartzware;

import java.lang.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.*;

/**
 StringVal is a data type which contains a line of plain text.
 @author Tony Johansen
 @version 0.7.1
*/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11/29/00 - Version 0.7.1 Tony Johansen
//                Added ADT headers to toString,
//                editValue, and setValue
//     11/17/00 - Ver 0.31 Ben Leinweber
//                Removed all the tabs from the file
//     11/16/00 - Ver 0.3 Ben Leinweber
//                Added Pre and Post Conditions.
//                Put pseudocode in between code
//     11/15/00 - Ver 0.2 Tony Johansen
//                added algorithm pseudocode.
//     10/31/00 - Ver 0.2 Tony Johansen
//                wrote ADT Headers.

public class StringVal extends Value {

    /**
     Constructs a StringVal with a given String.
     @param str the name of a String.

     PRE:  str is not null
     POST: all data members have been initialized
           an action listener has been added.
    */
    public StringVal(String str) {
        //INIT string to str.
        string = str;
    }

    /**
     Default Constructor

     PRE:  none
     POST: all data members have been initialized
           an action listener has been added.
    */
    public StringVal() {
        //INIT string to str.
        string = new String();
    }

    /**
     This function will allow the user to edit the value in this entry.  It
     returns true if in-label editing is required, but false if a dialog will
     handle the editing.
     @return Whether to do in label editing of this value

     PRE:  The entry that this Value is a part of must be in an open Edior
           Window
     POST: This value may be modified.
    */

    public boolean editValue() {
        return true;
    }

    /**
     This function sets the value of a string
     @param newValue The new value for the string.

     PRE:  newValue is not null.
     POST: the new string is created.
    */
    public void setValue(String newValue) {
        //INIT a new string with newValue
        string = new String(newValue);
    }

    /**
     This function returns a string.
     @return a string.

     PRE:  a cell in the resource bundle is clicked.
     POST: The String is used.
    */
    public String toString() {
        return string;
    }

    public Object clone() {
        return new StringVal(new String(string));;
    }

    //StringVal is made of a String type.
    private String string;
}
