/* Generated by Together */

package net.quartzware;

import java.awt.event.*;
import javax.swing.*;
import java.lang.*;
import java.util.*;

/**
 Displays a TaggedArray and allows the user to edit it
 @author Albert
 @version 0.7.1
*/

//  Version History
//      11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//               Checked for missing ADT Headers and pseudocode.
//               Converted tabs to spaces and fixed spacing errors
//      11/29/00 Version 0.7.1 Tony Johansen
//               Added GUI pseudocode.
//      11/27/00 Version 0.6 Chris Perluss
//                 Added GUI code.
//                 -Anthony Tomarchio - Internationalized
//      11/15/00 Version 0.2 Tony Johansen
//                 added algorithm pseudocode.
//      10/31/00 Version 0.1 Albert Lee
//                 wrote ADT Headers.

public class TaggedArrayDlg extends CenterDlg {

    // GUI elements declaration
    JList taggedArrayList = new JList(new String[]{"File.New.Project        :   New Project",
                                                   "File.Open.Open          :   Open",
                                                   "File.Open.Project       :   Open Project",
                                                   "File.Close              :   Close",
                                                   "File.Save.Save          :   Save",
                                                   "File.Save.SaveProjectAs :   Save Project As"});
    JTextField valueField = new JTextField("Save Project As");
    JLabel valueLabel = new JLabel();
    JButton setButton = new JButton();
    JButton cancelButton = new JButton();
    JButton newEntryButton = new JButton();
    JButton removeEntryButton = new JButton();
    JButton okButton = new JButton();

    //Internationalization variables
    Locale currentLocale = Locale.getDefault();
    ResourceBundle bundle = ResourceBundle.getBundle("RBEdit", currentLocale);

    /**
     This function constructs the Tagged Array dialog box and shows it
     @param ta is the particular tagged array used to set up the dialog box

     PRE: ta is not equal to null
     POST: the Dialog is created
    */
    public TaggedArrayDlg(TaggedArray ta) {
        super();
        //SET array to ta.
        array = ta;

        //CALL doTheLayout
        doTheLayout();

        //ADD listeners
        doAddListeners();

        //CALL pack.
        pack();

        // DISPLAY the dialog
        setVisible(true);
    }

    /**
     This function handles the layout of the tagged array dialog box
    */
    private void doTheLayout() {
        //INIT Tagged Array Dialog
        setTitle(bundle.getString("taggedArrayDlg"));
        setModal(true);
        setResizable(false);
        getContentPane().setLayout(null);
        setSize(405,265);

        //INIT Tagged Array List
        taggedArrayList.setBounds(12,12,384,132);
        getContentPane().add(taggedArrayList);

        //INIT Value Field
        valueField.setBounds(60,156,200,25);
        getContentPane().add(valueField);

        //INIT Value Lable
        valueLabel.setText(bundle.getString("valueLabel"));
        valueLabel.setForeground(java.awt.Color.black);
        valueLabel.setBounds(12,156,50,25);
        getContentPane().add(valueLabel);

        //INIT Set Button
        setButton.setText(bundle.getString("setButton"));
        setButton.setMnemonic((int)'S');
        setButton.setBounds(276,156,100,25);
        getContentPane().add(setButton);

        //INIT Cancel Button
        cancelButton.setText(bundle.getString("cancelButton"));
        cancelButton.setMnemonic((int)'C');
        cancelButton.setBounds(276,228,100,25);
        getContentPane().add(cancelButton);

        //INIT New Entry Button
        newEntryButton.setText(bundle.getString("newEntryButton"));
        newEntryButton.setBounds(96,192,125,25);
        getContentPane().add(newEntryButton);

        //INIT Remove Entry Button
        removeEntryButton.setText(bundle.getString("removeEntryButton"));
        removeEntryButton.setBounds(96,228,125,25);
        getContentPane().add(removeEntryButton);

        //INIT Ok Button
        okButton.setText(bundle.getString("okButton"));
        okButton.setMnemonic((int)'O');
        okButton.setBounds(276,192,100,25);
        getContentPane().add(okButton);
    }

    /**
     Adds necessary listeners

     PRE:  gui components have been initialized
     POST: gui componenets have listeners
    */
    public void doAddListeners() {
        cancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
            }
        });

        okButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
            }
        });

        setButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("This will allow the user to edit the currently selected string in the list");
            }
        });

        newEntryButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("This will add a new string to the list");
            }
        });

        removeEntryButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("This will remove the selected string from the list");
            }
        });
    }

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     */
    private TaggedArray array;
}
