/* Generated by Together */

package net.quartzware;

import java.lang.*;
import java.util.*;
import javax.swing.*;

/**
 The abstract base class from which all of the Data Types are derived
 @author Ben Leinweber
 @version 0.7.1
**/

// Version History
//     11/30/00 - Version 0.9   Ben Leinweber and Chris Perluss
//                Checked for missing ADT Headers and pseudocode.
//                Converted tabs to spaces and fixed spacing errors
//     11/29/00 - Version 0.7.1 Tony Johansen
//                Added new pseudocode and ADT headers
//                to getIcon and setValue.
//     11/16/00 - Ver 0.3 Ben Leinweber
//                Added Pre and Post Conditions
//     11/15/00 - Ver 0.2 Ben Leinweber
//                Added algorithm pseudocode
//     11/01/00 - Ver 0.1 Ben Leinweber
//                Initial Creation.  Javadoc code added.

public abstract class Value implements Cloneable {

    /**
     Default Constructor
     PRE:  None
     POST: class is created
    */
    public Value() {}   //do nothing

    /**
     This function will allow the user to edit the value in this entry.  It
     returns true if in-label editing is required, but false if a dialog will
     handle the editing.
     @return Whether to do in label editing of this value
     PRE:  The entry that this Value is a part of must be in an open Edior
           Window
     POST: This value may be modified.
    */
    public abstract boolean editValue();

    /**
     This function sets the value of a string
     @param newValue The new value for the string.

     PRE:  newValue is not null.
     POST: none
    */
    public void setValue(String newValue) {
        // do nothing
    }

    /**
     This function gets an Icon.
     @return The  specified icon.

     PRE:  There is a call for an icon.
     POST: The icon is displayed.
    */
    public Icon getIcon() {
        //INIT the name of the icon
        String name = getClass().getName();
        name = name.substring(name.lastIndexOf(".")+1);

        //RETURN the icon
        return new ImageIcon("/" + name + ".gif");
    }

    /**
     Returns an exact copy of this Entry
     @return the clone.

     PRE: none
     POST: a clone has been made
    */
    protected Object clone() throws CloneNotSupportedException {
        throw new CloneNotSupportedException("Cloner no baka: "
            + getClass().getName());
    }
}
